REST handlers fail when used with apps that copied old Lookup Editor code
Description

Associated revisions

Revision 541 - 06/21/2018 02:51 AM - lukemurphey

Fixing issue where REST handlers wouldn't work with apps that had copied code

Reference #2270

History

#1 - 06/19/2018 01:33 AM - Luke Murphey

The error is;
ImportError: cannot import name LookupEditor

from /home/SW/splunk/etc/apps/lookup_editor/bin/lookup_backups_rest_handler.py

#2 - 06/19/2018 01:46 AM - Luke Murphey

Questions:

e What is the path that is used for resolving libraries?
o See note, It does include
¢ Does a relative import work?
o No, it is in the same path
e Do the hosts have the modules available?
o Yes
¢ Does manually setting the sys.path to include the current directory work?
o No
e Why does it not output any logs?
o It does

Observations:

¢ The RHs are not starting, indicating: cannot import name LookupEditor
* The sys.path looks like it ought to work

References:

e https://stackoverflow.com/questions/67631/how-to-import-a-module-given-the-full-path
Could another app be including the lookup editor Python code? If so, would inserting the path first help?

1/3



https://stackoverflow.com/questions/67631/how-to-import-a-module-given-the-full-path

#3 - 06/19/2018 01:49 AM - Luke Murphey

Here is the sys.path on my mac:

o /Users/Imurphey/Splunk/711/lib/python2.7/site-packages/splunk/appserver/mrsparkle
e /Users/Imurphey/Splunk/711/lib/python2.7/site-packages/splunk/persistconn
¢ /Users/Imurphey/Splunk/711/lib/python2.7/site-packages

¢ /Users/Imurphey/stash/app-ess/test/common

e /Users/Imurphey/stash/common/test/ui

¢ /Users/Imurphey/stash/common/test

¢ /Users/Imurphey/Splunk/sp/lib/python2.7/site-packages

e /Users/Imurphey/Splunk/711/lib/python27.zip

e /Users/Imurphey/Splunk/711/lib/python2.7

¢ /Users/Imurphey/Splunk/711/lib/python2.7/plat-darwin

e /Users/Imurphey/Splunk/711/lib/python2.7/plat-mac

¢ /Users/Imurphey/Splunk/711/lib/python2.7/plat-mac/lib-scriptpackages

¢ /Users/Imurphey/Splunk/711/lib/python2.7/lib-tk

e /Users/Imurphey/Splunk/711/lib/python2.7/lib-old

¢ /Users/Imurphey/Splunk/711/lib/python2.7/lib-dynload

¢ /Users/Imurphey/Splunk/711/etc/apps/alert_logevent/bin

e /Users/Imurphey/Splunk/711/etc/apps/alert_webhook/bin

¢ /Users/Imurphey/Splunk/711/etc/apps/introspection_generator_addon/bin
¢ /Users/Imurphey/Splunk/711/etc/apps/lookup_editor/bin

e /Users/Imurphey/Splunk/711/etc/apps/search/bin

¢ /Users/Imurphey/Splunk/711/etc/apps/splunk_archiver/bin

¢ /Users/Imurphey/Splunk/711/etc/apps/splunk_instrumentation/bin

e /Users/Imurphey/Splunk/711/etc/apps/splunk_monitoring_console/bin

¢ /Users/Imurphey/Splunk/711/etc/system/bin

#4 - 06/19/2018 02:13 AM - Luke Murphey
Can set the import path to the script directory via:
import sys

import os
sys.path.append(os.path.dirname (os.path.abspath(___file_ )))

#5 - 06/20/2018 04:04 PM - Luke Murphey

| tried uploading a version of the app that does two things:

1. Try using the path set from the script directory
2. Outputs sys.path before starting
The app still doesn't work.

#7 - 06/20/2018 04:35 PM - Luke Murphey
Can dump apps with:

| rest /services/apps/local | table title label description

#8 - 06/21/2018 02:54 AM - Luke Murphey
- Status changed from New to Closed

- % Done changed from 0 to 100

#9 - 06/21/2018 02:55 AM - Luke Murphey
- Subject changed from Lookups cannot be loaded to REST handlers fail when used with apps that copied old Lookup Editor code
